/*
 * postal_errlist.c
 * Big table of error codes
 * libpostal project
 * libpost_raw gen code
 * $Id: postal_errlist.c,v 1.2 2003/07/16 11:50:49 fullermd Exp $
 */

/*
 * This needs to be kept manually in sync with the list in
 * ${base}/include/post_raw/post_raw.h.  We really should do better than
 * that...
 */
const char *const postal_errlist[] =
{
	/*  0 - POSTAL_E_WHOKNOWS */
		"Undefined error: Probably libpostal internal fault",
	/*  1 - POSTAL_E_NOERR */
		"No error: What're you checking for?",
	/*  2 - POSTAL_E_INVAL */
		"Invalid argument, or bad data in argument",
	/*  3 - POSTAL_E_NOMEM */
		"Can't allocate memory",
	/*  4 - POSTAL_E_NOHDR */
		"Attempt to change or delete non-existent header",
	/*  5 - POSTAL_E_DFORM */
		"Data format error in retrieved data",
	/*  6 - POSTAL_E_FSOP */
		"Filesystem operations error",
	/*  7 - POSTAL_E_LKFAIL */
		"Locking operation failed",
	/*  8 - POSTAL_E_SOCKET */
		"Socket error",
	/*  9 - POSTAL_E_NEXIST */
		"Something that should exist doesn't",
	/* 10 - POSTAL_E_EXIST */
		"Something that shouldn't exist does",
	/* 11 - POSTAL_E_SRVERR */
		"Error from network server",
	/* 12 - POSTAL_E_NOMSG */
		"No message collected (non-error)",
};

const int postal_nerr = sizeof(postal_errlist) / sizeof(postal_errlist[0]);
