/*
 * postal_flock.c
 * flock() lock a file
 * libpostal project
 * libpost_raw gen code
 * $Id: postal_flock.c,v 1.9 2003/06/03 13:31:00 fullermd Exp $
 */

#include <sys/file.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>

#include <post_raw.h>
#include <post_raw_p.h>
#include <post_raw_extra_p.h>

/*
 * These should be something other than global vars someday,
 * if we want to ever be threadsafe.
 */

unsigned flock_wait=1;
int flock_retry=5;

int
postal_flock(int tolock, int type)
{
	int count=0;

	while( (flock(tolock, (type|LOCK_NB) )!=0) )
	{
		if(errno!=EWOULDBLOCK)
			POSTAL_ERRSET_RI(POSTAL_E_LKFAIL, NULL);
		
		/*
		 * EWOULDBLOCK implies that somebody else already
		 * holds the lock.
		 * Wait and try again, unless we've already exceeded
		 * the number of retries.
		 */
		if(count>=flock_retry)
			POSTAL_ERRSET_RI(POSTAL_E_LKFAIL, NULL);

		count++;
		sleep(flock_wait);
	}
	
	/* If we got here, flock succeeded */
	return(0);
}
