/*
 * postal_free_conn.c
 * Free a POSTAL_CONN struct
 * libpostal project
 * libpost_raw gen code
 * $Id: postal_free_conn.c,v 1.6 2003/07/16 10:17:12 fullermd Exp $
 */

#include <stdlib.h>

#include <post_raw.h>
#include <post_raw_p.h>
#include <post_raw_maildir_p.h>
#include <post_raw_mbox_p.h>
#include <post_raw_pop_p.h>
#include <post_raw_extra_p.h>


void
postal_free_conn(POSTAL_CONN *tofree)
{
	if(!tofree)
		return;

	/* See what we've got and need to free */
	/* XXX These still leak.  Need recursion.  Fix later.  Ugh. */
	switch(tofree->conn_type)
	{
		case SRC_NONE:
			/* Do nothing */
			break;
		case SRC_POP:
			pop_free_spec(tofree->spec.pop);
			break;
		case SRC_MBOX:
			mbox_free_spec(tofree->spec.mbox);
			break;
		case SRC_MDIR:
			maildir_free_spec(tofree->spec.mdir);
			break;
	}

	postal_free_msggroup(tofree->msgs);
	free(tofree);
}
