/*
 * postal_pthread.c
 * pthread-related functions
 * libpostal project
 * libpost_raw gen code
 * $Id: postal_pthread.c,v 1.1 2003/06/03 11:32:03 fullermd Exp $
 */

#include <stdlib.h>
#include <pthread.h>

#include <post_raw.h>
#include <post_raw_p.h>
#include <post_raw_extra_p.h>


/* Suck in some globals */
extern pthread_key_t postal_errfoo_key;


/* Initialize pthread-related stuff process-wide */
int
postal_pthread_init(void)
{

	if(pthread_key_create(&postal_errfoo_key, NULL)==0)
		return(0);
	else
		return(-1);
}


/* Initialize pthread-related stuff for one thread */
int
postal_pthread_thread_init(void)
{
	POSTAL_ERRFOO_T *postal_errfoo;

	postal_errfoo = malloc(sizeof(POSTAL_ERRFOO_T));
	if(postal_errfoo==NULL)
		return(-1);
	
	if(pthread_setspecific(postal_errfoo_key, (void *)postal_errfoo)==0)
		return(0);
	else
		return(-2);
}


/* Cleanup pthread-related stuff for one thread */
void
postal_pthread_thread_fini(void)
{
	POSTAL_ERRFOO_T *postal_errfoo;

	postal_errfoo = (POSTAL_ERRFOO_T *)pthread_getspecific(postal_errfoo_key);
	if(postal_errfoo==NULL)
		return;
	
	free(postal_errfoo);

	return;
}
