/*
 * maildir_get_status.c
 * Get status info from a maildir-derived message
 * libpostal project
 * libpost_raw maildir code
 * $Id: maildir_get_status.c,v 1.4 2003/07/16 10:38:52 fullermd Exp $
 */

#include <stdlib.h>
#include <string.h>

#include <post_raw.h>
#include <post_raw_p.h>
#include <post_raw_maildir_p.h>
#include <post_raw_extra_p.h>


int
maildir_get_status(POSTAL_MSG *msg)
{
	int statae=STATUS_NULL;
	char *buf;

	/* In Maildir's, we determine status from a few things */

	/* If it's in 'new', it doesn't have any flags at all */
	if(msg->loc.file->loc == LOC_NEW)
		return(STATUS_NEW);

	/* So, it's old' if nothing else */
	statae |= STATUS_OLD;

	/* Break down the filename */
	buf = msg->loc.file->info;
	if( !(strncmp(buf, "2,", 2)) )
	{
		/* More info */
		buf+=2;
		if(strchr(buf, 'R'))
			statae |= STATUS_REPLIED;
		if(strchr(buf, 'S'))
			statae |= STATUS_READ;

		/* Other flags we don't catch right now */
	}

	return(statae);
}
