/*
 * mbox_set_conlen.c
 * Set the Content-Length: header
 * libpostal project
 * libpost_raw mbox code
 * $Id: mbox_set_conlen.c,v 1.3 2003/06/04 08:24:50 fullermd Exp $
 */

#include <stdio.h>
#include <string.h>

#include <post_raw.h>
#include <post_raw_p.h>
#include <post_raw_mbox_p.h>
#include <post_raw_extra_p.h>


int
mbox_set_conlen(POSTAL_MSG *msg)
{
	size_t blen;
	/*
	 * XXX Hardcoded length.
	 * Now, if we need more than 255 digits of space to write out the
	 * size of a message, we're in big fscking trouble, because that'll
	 * easily overflow a size_t on any platform we're likely to have in
	 * my lifetime.
	 */
	char lenstr[256];

	/* Extra validation */
	blen = strlen(msg->body);
	if(msg->bodylen != blen)
	{
		/* Bodylen is off. */
		msg->bodylen = blen;
	}
	
	sprintf(lenstr, "%li", (long)msg->bodylen);
	return(postal_set_header(msg, "Content-Length:", lenstr));
}
