/*
 * mbox_set_status.c
 * Set the Status: header
 * libpostal project
 * libpost_raw mbox code
 * $Id: mbox_set_status.c,v 1.3 2003/06/05 11:19:30 fullermd Exp $
 */

#include <string.h>

#include <post_raw.h>
#include <post_raw_p.h>
#include <post_raw_mbox_p.h>
#include <post_raw_extra_p.h>


int
mbox_set_status(POSTAL_MSG *msg)
{
	/*
	 * XXX Hardcoded length.
	 * These are generally only a few chars in length.  I've never seen
	 * more than, say, 3 chars.
	 */
	char statstr[16];
	char xstatstr[16];

	bzero(statstr, 16);
	bzero(xstatstr, 16);

	/* If no changes or no status, let it be */
	if( (msg->stat_new==msg->stat_loc) || (msg->stat_new==STATUS_NULL) )
		return(0);

	/* Else, set it all from scratch */
	/* Special case: No Status: line at all */
	if(msg->stat_new & STATUS_NEW)
	{
		if((postal_del_header(msg, "Status:"))<0)
			POSTAL_ERRRET_RI; /* Preserve p_errno */
	}
	else
	{
		if(msg->stat_new & STATUS_OLD)
			strcat(statstr, "O");
		if(msg->stat_new & STATUS_READ)
			strcat(statstr, "R");
		if(msg->stat_new & STATUS_REPLIED)
			strcat(xstatstr, "A");
	}


	if(strlen(statstr)>0)
		if((postal_set_header(msg, "Status:", statstr))<0)
			POSTAL_ERRRET_RI; /* Preserve p_errno */
	if(strlen(xstatstr)>0)
		if((postal_set_header(msg, "X-Status:", xstatstr))<0)
			POSTAL_ERRRET_RI; /* Preserve p_errno */

	return(0);
}
