/*
 * pop_answer_check.c
 * POP reply checker
 * libpostal project
 * libpost_raw  POP code
 * $Id: pop_answer_check.c,v 1.7 2003/06/04 09:18:25 fullermd Exp $
 */

#include <sys/types.h>
#include <sys/uio.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

#include <post_raw.h>
#include <post_raw_p.h>
#include <post_raw_pop_p.h>
#include <post_raw_extra_p.h>


/* Internal function */
int
pop_answer_check(POSTAL_CONN *p_conn)
{
	char buf[BUFFER_SIZE];
	ssize_t readlen;

	/* Get the response */
	readlen = postal_get_line(p_conn->spec.pop->sock, buf, (BUFFER_SIZE-1));
	if(readlen<=0)
		POSTAL_ERRSET_RI(POSTAL_E_SOCKET, NULL);
	buf[readlen]='\0';

	/* Check it */
	if( (strncmp(buf, POP_GOOD, strlen(POP_GOOD)) != 0) )
		POSTAL_ERRSET_RI(POSTAL_E_SRVERR, NULL);

	/* Got here, we're good */
	return(0);
}
