/*
 * getmsgs.c
 * Test the pop_retr() and prereq functions.
 * Specially designed to work in the compile tree
 * Links again: libpost_raw
 * Links shared
 * $Id: getmsgs.c,v 1.3 2003/07/16 12:04:32 fullermd Exp $
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include "../../include/post_raw/post_raw.h"


int
main(int argc, char *argv[])
{
	POSTAL_CONN *my_conn;
	POP_RET_STAT *ret_stat;
	int dele=0;
	int goch;
	int mnum;
	char *p_serv, *p_user, *p_pass;
	POSTAL_MSG *msg;

	if(argc<6)
	{
		printf("Need at least -h -u -p arguments, damn you!\n");
		exit(1);
	}

	while ( (goch = getopt(argc, argv, "dh:u:p:")) != -1 )
		switch((char)goch)
		{
			case 'd':
				/* Do DELE's */
				dele = 1;
				break;
			case 'h':
				/* Hostname */
				p_serv = optarg;
				break;
			case 'u':
				/* Username */
				p_user = optarg;
				break;
			case 'p':
				/* Password */
				p_pass = optarg;
				break;
			default:
				printf("Bad argument '%c'\n", goch);
				exit(1);
				/* NOTREACHED */
		}

	argc -= optind;
	argv += optind;

	printf("Running with host '%s', user '%s', and pass '%s'\n",
			p_serv, p_user, p_pass);

	my_conn = pop_connect(p_serv, p_user, p_pass);

	if(!my_conn)
	{
		printf("You lose, too bad!\n");
		exit(1);
	}

	/* Do a STAT to see how many messages we have */
	ret_stat = pop_stat(my_conn);
	printf("STAT returned %u messages, with %lu total bytes\n",
			pop_stat_msgs(ret_stat), pop_stat_bytes(ret_stat));

	/* Retrieve the messages in order */
	for(mnum=1 ; mnum < pop_stat_msgs(ret_stat) ; mnum++)
	{
		msg = pop_retr(my_conn, mnum);
		printf("Message #%d:\n------\n%s\n%s\n------\n",
				mnum, postal_msg_header(msg),
				postal_msg_body(msg) );
		/* CLEAR! */
		postal_free_msg(msg);
	}
		
	if(dele)
	{
		/* Delete the messages, too */
		for(mnum = 1 ; mnum <= pop_stat_msgs(ret_stat) ; mnum++)
			pop_dele(my_conn, mnum);
	}

	pop_free_retstat(ret_stat);
	pop_close(my_conn);

	exit(0);
}
