/*
 * getmsgs.c
 * Test the pop_retr() and prereq functions.
 * Specially designed to work in the compile tree
 * Links again: libpost_raw
 * Links shared
 * $Id: getmsgs2.c,v 1.4 2002/01/21 17:50:07 fullermd Exp $
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include "../../include/post_raw/post_raw.h"


int
main(int argc, char *argv[])
{
	POSTAL_CONN *my_conn;
	POSTAL_MSG *msg;
	POSTAL_MSG_GROUP *ret_msgs;
	int dele=0;
	int goch;
	int mnum;
	char *p_serv, *p_user, *p_pass;

	if(argc<6)
	{
		printf("Need at least -h -u -p arguments, damn you!\n");
		exit(1);
	}

	while ( (goch = getopt(argc, argv, "dh:u:p:")) != -1 )
		switch((char)goch)
		{
			case 'd':
				/* Do DELE's */
				dele = 1;
				break;
			case 'h':
				/* Hostname */
				p_serv = optarg;
				break;
			case 'u':
				/* Username */
				p_user = optarg;
				break;
			case 'p':
				/* Password */
				p_pass = optarg;
				break;
			default:
				printf("Bad argument '%c'\n", goch);
				exit(1);
				/* NOTREACHED */
		}

	argc -= optind;
	argv += optind;

	printf("Running with host '%s', user '%s', and pass '%s'\n",
			p_serv, p_user, p_pass);

	my_conn = pop_connect(p_serv, p_user, p_pass);

	if(!my_conn)
	{
		printf("You lose, too bad!\n");
		exit(1);
	}

	/* Get all the messages at once with pop_retr_all() */
	ret_msgs = pop_retr_all(my_conn, dele);

	/* Print them all */
	for(mnum=1 ; mnum < postal_mgroup_num(ret_msgs) ; mnum++)
	{
		msg = postal_mgroup_getmsg(ret_msgs, mnum);
		printf("Message #%d:\n------\n%s\n%s\n------\n",
				mnum, postal_msg_header(msg),
				postal_msg_body(msg) );
	}

	/* Free things up */
	postal_free_msggroup(ret_msgs);

	pop_close(my_conn);

	exit(0);
}
