/*
 * listtest.c
 * Test the pop_list() and pre-req functions
 * Specially designed to work in the compile tree
 * Links again: libpost_raw
 * Links shared
 * $Id: listtest.c,v 1.5 2003/07/16 12:04:32 fullermd Exp $
 */

#include <stdio.h>
#include <stdlib.h>

#include "../../include/post_raw/post_raw.h"

#ifdef USE_DMALLOC
#include <dmalloc.h>
#endif

int
main(int argc, char *argv[])
{
	POSTAL_CONN *my_conn;
	POP_RET_STAT *ret_stat;
	POP_RET_LIST *ret_list, *litem;
	char *p_serv, *p_user, *p_pass;

	argv++ ; argc--;

	if(argc != 3)
	{
		printf("Usage: %s <host> <user> <pass>\n", *(argv-1));
		exit(1);
	}

	p_serv = *argv;
	argv++ ; argc--;
	p_user = *argv;
	argv++ ; argc--;
	p_pass = *argv;
	argv++ ; argc--;

	printf("Running with host '%s', user '%s', and pass '%s'\n",
			p_serv, p_user, p_pass);

	my_conn = pop_connect(p_serv, p_user, p_pass);

	if(!my_conn)
	{
		printf("You lose, too bad!\n");
		exit(1);
	}

	ret_stat = pop_stat(my_conn);

	printf("STAT returned %u messages, with %lu total bytes\n",
			pop_stat_msgs(ret_stat), pop_stat_bytes(ret_stat));

	pop_free_retstat(ret_stat);

	ret_list = pop_list(my_conn);
	printf("Results from LIST:\n");
	for(litem = ret_list ; litem ; litem = pop_list_mnext(litem))
	{
		printf("Message %u contains %lu bytes\n",
				pop_list_mnum(litem), pop_list_msize(litem));
	}
	
	pop_free_retlist(ret_list);

	pop_close(my_conn);

	exit(0);
}
